########################################
#Author: dirty
#version: 1.0
#Description: A simple script that let`s you add topics by a single word and set them very easy.
#
#Ex: !info add WORD topic you wanna add for the word <-- will add the topic to the WORD
#    !topic WORD <-- will set the topic added to the WORD
########################################
 

# PLEASE CHANGE THE LINE BELOW. If you don't, the file and the directory will be
# created
set topic_db "data/topic.dat"


### - ### No need to edit below this line... ### - ###

putlog "!info TCL by dirty @ irc.planetsurge.net #eggdrop"

bind pub m !info topic_learn
bind pub o !topic topic_explain
bind pub o "\*\*" topic_search

set topic_whodid ""
bind pub o !list topic_definitions 

set ztchan "#zT.noise"

proc topic_definitions {n u h c a} { 
    global topic_db ztchan
    puthelp "PRIVMSG $ztchan :\[   Listing..   \]"
    set lista ""
    set fp [open $topic_db r]
    while {![eof $fp]} {lappend lista [lindex [split [gets $fp] " "] 1]}
    close $fp
    foreach {a b c d e f g h i j k l m n o p q r s t u v w x y z} [lsort -unique $lista] {puthelp "PRIVMSG $ztchan :Topics: $a $b $c $d $e $f $g $h $i $j $k $l $m $n $o $p $q $r $s $t $u $v $w $x $y $z" }
    puthelp "PRIVMSG $ztchan :\[   == END ==   \]" }

proc date {} {
  strftime "%d %b %Y" }

proc topic_learn { nick uhost hand chan args } {
 set args [lindex $args 0]
 set args [split $args " "]
 switch [lindex $args 0] {
  "add" {
   if {[lindex $args 2] == ""} {
    puthelp "NOTICE $nick :Try !info add <word> <topic>" 
   } else {
      topic_addEntry $nick [lindex $args 1] [lrange $args 2 end]
      puthelp "NOTICE $nick :Topic added"
      topic_flood "[lindex $args 1]" $chan
     }
  }
  "del" {
   if {[lindex $args 1] == ""} {
      puthelp "NOTICE $nick :Try !info del <word> *"
     }
   if {[lindex $args 2] != ""} {
    topic_delEntry [lindex $args 1] [lindex $args 2]
    puthelp "NOTICE $nick :Topic removed"
    topic_flood "[lindex $args 1]" $chan
   } 
   if {[lindex $args 2] == "*"} {
      topic_delEntry [lindex $args 1]
     }
  }
  "ins" {
   if {[lindex $args 3]!=""} {
    topic_insEntry [lindex $args 1] [lindex $args 2] [lrange $args 3 end]
    puthelp "NOTICE $nick :Info inserted"
    topic_flood "[lindex $args 1]" $chan
   } else {puthelp "NOTICE $nick :Syntax: .reop ins <chan> <num> <info>" }
  }
  "put" {
   if {[lindex $args 3]!=""} {
    topic_putEntry [lindex $args 1] [lindex $args 2] [lrange $args 3 end] $nick
    puthelp "NOTICE $nick :Info inserted"
    topic_flood "[lindex $args 1]" $chan
   } else {puthelp "NOTICE $nick :Syntax: .reop put <chan> <num> <info>" }
  }
  default { puthelp "NOTICE $nick :Syntax: \002!info <add|del>" }
 }
}

proc topic_explain { nick uhost hand chan args } {
	global topic_db topic_whodid;if {![info exists topic_whodid]} {set topic_whodid ""}
	set real_chan $chan
	set args [split [lindex $args 0] " "]
	if {$args == ""} { puthelp "PRIVMSG $chan :\002Usage: !see <word>" ; return }
	set explain [string tolower [lindex $args 0]]; set chan [string tolower $chan]
	if {([lindex $args 1] == ">" || [lindex $args 1] == ">>") && [lindex $args 2] != ""} { set chan [lindex $args 2] 
#         if {[lsearch -exact $topic_whodid [list $explain [string tolower $chan]]] != -1} {
#                puthelp "PRIVMSG $real_chan :\002Hey ${nick}, i've already set $chan topic to \"$explain\"... no need to reset it (i think)"
#                return 0
#         }
	}
	set fp [open $topic_db r];set allEntrys ""
	while {![eof $fp]} {gets $fp curEntry;set curEntry [split $curEntry " "];if {[string equal -nocase [lindex $curEntry 1] $explain]} {lappend allEntrys [join $curEntry " "]}}
	close $fp
	set count 0
	if {[llength $allEntrys]==1} {
	 if {[lsearch -exact $topic_whodid [list $explain [string tolower $chan]]] != -1} {
		puthelp "PRIVMSG $real_chan :\002Hey ${nick}, i've already told $chan about \"$explain\"... no need to repeat (i think)"
		return 0
	 } else { puthelp "TOPIC $chan :[join [lrange [split [lindex $allEntrys 0] " "] 2 end]] ($nick)";incr count }
	} else {
	 if {[llength $allEntrys]>6&&[string index $chan 0]=="#"&&!(([lindex $args 1] == ">" || [lindex $args 1] == ">>") && [lindex $args 2] != "")} {set chan $nick; 
          puthelp "PRIVMSG $real_chan :\002\037${explain}?\002\037 What a huge defenition... i'll tell you in private instead..."
	 }
         if {[lsearch -exact $topic_whodid [list $explain [string tolower $chan]]] != -1} {
                puthelp "PRIVMSG $real_chan :\002Hey ${nick}, i've already set $chan topic to \"$explain\"... no need to reset it (i think)"
                return 0
	 }
	 foreach curEntry $allEntrys {
		incr count
		putserv "TOPIC $chan :\002\037${explain}\[\037\002${count}\002\037]:\037 \002[join [lrange [split $curEntry " "] 2 end]]"
	} }
	if {$count == 0} { puthelp "NOTICE $nick :\002${explain}: \002No info found for topic." }
	if {([lindex $args 1] == ">" || [lindex $args 1] == ">>") && [lindex $args 2] != ""} {
		puthelp "NOTICE $nick :Ok, done."
	}
	lappend topic_whodid [list $explain [string tolower $chan]]
	set explain [topic_filterstr $explain]	;# Don't allow code to be executed
	set chan [topic_filterstr $chan]	;# ensure []s are properly handled...
	utimer 60 "topic_flood \"$explain\" \"$chan\""
}

proc topic_flood {word target} {
	# removes from "already told so" list
	global topic_whodid
	set word [string tolower $word]; set target [string tolower $target]
	set lin [lsearch -exact $topic_whodid [list $word $target]] 
	if {$lin == -1} {
		return
	} else {
		set topic_whodid [lreplace $topic_whodid $lin $lin]
	}
}

proc topic_addEntry { nick word defenition } {
 global topic_db;set word [string tolower $word]
 if {![file exists $topic_db]} {file mkdir [lindex [split $topic_db /] 0];set fp [open $topic_db w+]
  puts $fp "!info hal-learn script | mantained by the #Eggdrop team at irc.planetsurge.net"
 } else {set fp [open $topic_db a]};puts $fp "$nick $word [join $defenition]";close $fp
}

proc topic_delEntry { word {remnum "all"}} {
 global topic_db
 set word [string tolower $word]
 set fp [open $topic_db r]
 set allEntrys ""
 set count 1
 if {$remnum == "all"} {
  while {![eof $fp]} {gets $fp curEntry;if {![string equal -nocase [lindex [split $curEntry] 1] $word]} {lappend allEntrys $curEntry}}
 } else {
  while {![eof $fp]} {
   gets $fp curEntry
   if {![string equal -nocase [lindex [split $curEntry] 1] $word] || ($count != $remnum && $remnum != -2)} {
    if {[info exists curEntry]&&$curEntry!=""} {lappend allEntrys $curEntry}
    if {[string equal -nocase [lindex [split $curEntry] 1] $word]} {incr count}
   } else {incr count}
  }
 }
 close $fp;set fp [open $topic_db w];foreach curEntry $allEntrys {puts $fp $curEntry};close $fp
}

proc topic_insEntry {word num text} {
 global topic_db nick
 set word [string tolower $word]
 set fp [open $topic_db r]
 set allEntrys ""
 set count 1
 while {![eof $fp]} {
  gets $fp curEntry
  if {![string equal -nocase [lindex [split $curEntry] 1] $word] || ($count != $num && $num != -2)} {
   if {[info exists curEntry]&&$curEntry!=""} {lappend allEntrys $curEntry}
   if {[string equal -nocase [lindex [split $curEntry] 1] $word]} {incr count}
  } else {incr count;lappend allEntrys "$curEntry [join $text]"}
 }
 close $fp;set fp [open $topic_db w];foreach curEntry $allEntrys {puts $fp $curEntry};close $fp
}

proc topic_putEntry {word num text {whodid "."}} {
 global topic_db nick
 set word [string tolower $word]
 set fp [open $topic_db r]
 set allEntrys ""
 set count 1
 if {$num==1} {lappend allEntrys "$whodid $word [join $text]"}
 while {![eof $fp]} {
  gets $fp curEntry
  if {[string equal -nocase [lindex [split $curEntry] 1] $word]} {incr count}
  if {[info exists curEntry]&&$curEntry!=""} {lappend allEntrys $curEntry}
  if {$count==$num&&$num!=1} {lappend allEntrys "$whodid $word [join $text]"}
 }
 close $fp;set fp [open $topic_db w];foreach curEntry $allEntrys {puts $fp $curEntry };close $fp
}
  

proc topic_repEntry {word num text} {
 global topic_db nick
 set word [string tolower $word]
 set fp [open $topic_db r]
 set allEntrys ""
 set count 1
 while {![eof $fp]} {
  gets $fp curEntry
  if {![string equal -nocase [lindex [split $curEntry] 1] $word] || ($count != $num && $num != -2)} {
   if {[info exists curEntry]&&$curEntry!=""} {lappend allEntrys $curEntry}
   if {[string equal -nocase [lindex [split $curEntry] 1] $word]} {incr count}
  } else {incr count;lappend allEntrys "[lrange [split $curEntry] 0 1] [join $text]"}
 }
 close $fp;set fp [open $topic_db w];foreach curEntry $allEntrys {puts $fp $curEntry};close $fp
}

proc topic_sortFile {a c d e f} {
 global topic_db
 set t_count [clock clicks -milliseconds]
 set fp [open $topic_db r]
 set allEntrys ""
 while {![eof $fp]} {
  set curEntry [gets $fp]
  if {[info exists curEntry]&&$curEntry!=""} {lappend allEntrys [split $curEntry " "]}
 }
 close $fp; set allEntrys [lsort -index 1 $allEntrys]
 set fp [open $topic_db w];foreach curEntry $allEntrys {puts $fp [join $curEntry " "]};close $fp
 putlog "!info \[by dirty@planetsurge\]-> Done with sorting of data on the database ($topic_db)->[expr double([clock clicks -milliseconds]-$t_count)/1000]s"
}
bind time - "12 * * * *" topic_sortFile

proc topic_filterstr { data } {
 regsub -all -- \\\\ $data \\\\\\\\ data
 regsub -all -- \\\[ $data \\\\\[ data	
 regsub -all -- \\\] $data \\\\\] data
 regsub -all -- \\\} $data \\\\\} data
 regsub -all -- \\\{ $data \\\\\{ data
 regsub -all -- \\\" $data \\\\\" data
 return $data
}

proc topic_search { nick uhost hand chan args } {
 global topic_db
 set args [string tolower [lindex $args 0]]
 if {$args=="" && [isop $nick]} {
    topic_definitions $nick $uhost $hand $chan ""
    return
    } elseif {$args=="" && ![isop $nick]} {
    puthelp "PRIVMSG $chan :\002Sorry, no access.\002"
    return
    }
 set init_t [clock clicks -milliseconds]
 set fp [open $topic_db r];set matches "";set allEntrys ""
 while {![eof $fp]} {
  gets $fp curEntry;if {[info exists curEntry]&&$curEntry!=""} {
   set curEntry [split [string tolower $curEntry] " "]; set thisEntry [join [lrange $curEntry 1 end] " "]
   if {[string match -nocase "*${args}*" $thisEntry]} {
#    putserv "PRIVMSG #meta :worked $curEntry"
    if {[lsearch $allEntrys [lindex curEntry 1]]==-1} {lappend allEntrys [lindex $curEntry 1];set allEntrys [lsort -unique $allEntrys]}
 } } } ;set init_t [expr double(([clock clicks -milliseconds] - $init_t))/1000]
 if {$allEntrys==""} {puthelp "PRIVMSG $chan :Sorry, no matches for $args on the defenition database. (\002\037${init_t}\037s)"
 } else {
  if {[llength $allEntrys]>10} {puthelp "PRIVMSG $chan :\002Too much matches.\002 Please try a more complex search."
  } else {puthelp "PRIVMSG $chan :\002Found \037[llength $allEntrys]\037 matches.\002 Sorted: \037[join [lsort -dictionary $allEntrys] "\037, \037"]\037. (\002\037${init_t}\037s)"
  }
 }
}

